%{?mingw_package_header}

Name:           mingw-SDL
Version:        1.2.15
%define subrel  1
Release:        %mkrel 8
Summary:        MinGW Windows port of SDL cross-platform multimedia library

License:        LGPLv2+
Group:          Development/Other
URL:            http://www.libsdl.org/
Source0:        http://www.libsdl.org/release/SDL-%{version}.tar.gz

# Synced with Fedora
Patch100:	SDL-1.2.15-CVE-2019-7577-Fix-a-buffer-overread-in-MS_ADPCM_deco.patch
# Fix CVE-2019-7575 (a buffer overwrite in MS_ADPCM_decode), bug #1676744,
# upstream bug #4493, proposed to upstream
Patch101:	SDL-1.2.15-CVE-2019-7575-Fix-a-buffer-overwrite-in-MS_ADPCM_dec.patch
# Fix CVE-2019-7574 (a buffer overread in IMA_ADPCM_decode), bug #1676750,
# upstream bug #4496, proposed to upstream
Patch102:	SDL-1.2.15-CVE-2019-7574-Fix-a-buffer-overread-in-IMA_ADPCM_dec.patch
# Fix CVE-2019-7572 (a buffer overread in IMA_ADPCM_nibble), bug #1676754,
# upstream bug #4495, proposed to upstream
Patch103:	SDL-1.2.15-CVE-2019-7572-Fix-a-buffer-overread-in-IMA_ADPCM_nib.patch
# Fix CVE-2019-7572 (a buffer overwrite in IMA_ADPCM_nibble), bug #1676754,
# upstream bug #4495, proposed to upstream
Patch104:	SDL-1.2.15-CVE-2019-7572-Fix-a-buffer-overwrite-in-IMA_ADPCM_de.patch
# Fix CVE-2019-7573, CVE-2019-7576 (buffer overreads in InitMS_ADPCM),
# bugs #1676752, #1676756, upstream bugs #4491, #4490, proposed to upstream
Patch105:	SDL-1.2.15-CVE-2019-7573-CVE-2019-7576-Fix-buffer-overreads-in-.patch
# Fix CVE-2019-7578, (a buffer overread in InitIMA_ADPCM), bug #1676782,
# upstream bug #4491, proposed to upstream
Patch106:	SDL-1.2.15-CVE-2019-7578-Fix-a-buffer-overread-in-InitIMA_ADPCM.patch
# Fix CVE-2019-7638, CVE-2019-7636 (buffer overflows when processing BMP
# images with too high number of colors), bugs #1677144, #1677157,
# upstream bugs #4500, #4499, in upstream after 1.2.15
Patch107:	SDL-1.2.15-CVE-2019-7638-CVE-2019-7636-Refuse-loading-BMP-image.patch
# Fix CVE-2019-7637 (an integer overflow in SDL_CalculatePitch), bug #1677152,
# upstream bug #4497, in upstream after 1.2.15
Patch108:	SDL-1.2.15-CVE-2019-7637-Fix-in-integer-overflow-in-SDL_Calcula.patch
# Fix CVE-2019-7635 (a buffer overread when blitting a BMP image with pixel
# colors out the palette), bug #1677159, upstream bug #4498,
# proposed to upstream
Patch109:	SDL-1.2.15-CVE-2019-7635-Reject-BMP-images-with-pixel-colors-ou.patch
# Reject 2, 3, 5, 6, 7-bpp BMP images (related to CVE-2019-7635),
# bug #1677159, upstream bug #4498, in upstream after 1.2.15
Patch110:	SDL-1.2.15-Reject-2-3-5-6-7-bpp-BMP-images.patch
# Fix CVE-2019-7577 (Fix a buffer overread in MS_ADPCM_nibble and
# MS_ADPCM_decode on an invalid predictor), bug #1676510, upstream bug #4492,
# proposed to upstream
Patch111:	SDL-1.2.15-CVE-2019-7577-Fix-a-buffer-overread-in-MS_ADPCM_nibb.patch

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw32-win-iconv

BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-win-iconv

# Not required at the moment, but SDL does contain plenty of C++ code,
# I just haven't worked out how to enable it.
#BuildRequires:  mingw32-gcc-c++

%ifarch %{ix86}
BuildRequires: nasm
%endif


%description
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


# Win32
%package -n mingw32-SDL
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Requires:       pkgconfig
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw32-win-iconv

%description -n mingw32-SDL
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Win32
%package -n mingw64-SDL
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Requires:       pkgconfig
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw64-win-iconv

%description -n mingw64-SDL
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


%?mingw_debug_package


%prep
%setup -q -n SDL-%{version}

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1


%build
%mingw_configure
%mingw_make %{?_smp_mflags}


%install
%mingw_make DESTDIR=$RPM_BUILD_ROOT install

# Remove static libraries but DON'T remove *.dll.a files.
rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDL.a
rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDL.a

# Actually libSDLmain.a seems to be required.  It just contains
# a single object file called SDL_win32_main.o.
#rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDLmain.a
#rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDLmain.a

# Delete man pages since they duplicate what is already available
# in base Fedora package.
rm $RPM_BUILD_ROOT%{mingw32_mandir}/man3/*.3*
rm $RPM_BUILD_ROOT%{mingw64_mandir}/man3/*.3*

# Drop all .la files
find $RPM_BUILD_ROOT -name "*.la" -delete


# Win32
%files -n mingw32-SDL
%doc COPYING
%{mingw32_bindir}/SDL.dll
%{mingw32_bindir}/sdl-config
%{mingw32_libdir}/libSDL.dll.a
%{mingw32_libdir}/libSDLmain.a
%{mingw32_libdir}/pkgconfig/sdl.pc
%{mingw32_datadir}/aclocal/sdl.m4
%{mingw32_includedir}/SDL

# Win64
%files -n mingw64-SDL
%doc COPYING
%{mingw64_bindir}/SDL.dll
%{mingw64_bindir}/sdl-config
%{mingw64_libdir}/libSDL.dll.a
%{mingw64_libdir}/libSDLmain.a
%{mingw64_libdir}/pkgconfig/sdl.pc
%{mingw64_datadir}/aclocal/sdl.m4
%{mingw64_includedir}/SDL




%changelog
* Fri Mar 29 2019 akien <akien> 1.2.15-8.1.mga6
+ Revision: 1381075
- Sync security patches with Fedora: Tue Mar 12 2019 Petr Pisar <ppisar@redhat.com> - 1.2.15-38
  o Fix CVE-2019-7577 completely (a buffer overread in MS_ADPCM_nibble and
    MS_ADPCM_decode on an invalid predictor) (bug #1676510)
  o Fix CVE-2019-7577 (a buffer overread in MS_ADPCM_decode) (bug #1676510)
  o Fix CVE-2019-7575 (a buffer overwrite in MS_ADPCM_decode) (bug #1676744)
  o Fix CVE-2019-7574 (a buffer overread in IMA_ADPCM_decode) (bug #1676750)
  o Fix CVE-2019-7572 (a buffer overread in IMA_ADPCM_nibble) (bug #1676754)
  o Fix CVE-2019-7572 (a buffer overwrite in IMA_ADPCM_nibble) (bug #1676754)
  o Fix CVE-2019-7573, CVE-2019-7576 (buffer overreads in InitMS_ADPCM)
    (bugs #1676752, #1676756)
  o Fix CVE-2019-7578 (a buffer overread in InitIMA_ADPCM) (bug #1676782)
  o Fix CVE-2019-7638, CVE-2019-7636 (buffer overflows when processing BMP
    images with too high number of colors) (bugs #1677144, #1677157)
  o Fix CVE-2019-7637 (an integer overflow in SDL_CalculatePitch) (bug #1677152)
  o Fix CVE-2019-7635 (a buffer overread when blitting a BMP image with pixel
    colors out the palette) (bug #1677159)
  o Reject 2, 3, 5, 6, 7-bpp BMP images (bug #1677159)

* Mon Feb 08 2016 umeabot <umeabot> 1.2.15-8.mga6
+ Revision: 946390
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.2.15-7.mga5
+ Revision: 739992
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.2.15-6.mga5
+ Revision: 682401
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 1.2.15-5.mga4
+ Revision: 536153
- Mageia 4 Mass Rebuild

* Sun Sep 22 2013 neoclust <neoclust> 1.2.15-4.mga4
+ Revision: 483376
- imported package mingw-SDL

